/**
* This project is owned by Dead Studios
* DO NOT SHARE THIS ADD-ON WITHOUT THE PROPER PERMISSION
*/
/**
 * Discord: idkdeadxd
 * Note: all the code in this add-on is obfuscated so do not try and dig :D
 */

//_________________________________/File Imports\_________________________________\\


import { Main } from './community_panel/main_menu'
import { Admin_Main } from './admin/main_menu'
import { help_command, clear_chat, devCheck, flyy, giveBook, Bad, Good, freeKit, LockChat, StartupMessage, info } from './chat_commands'
import './homes'
import './kits_system'



//_________________________________/ Game Imports \_________________________________\\

import { world, system } from '@minecraft/server'

//_________________________________/ Form Opening Events \_________________________________\\

world.afterEvents.itemUse.subscribe((data) => {
    const player = data.source;
    const item = data.itemStack;
    const Value = world.getDynamicProperty('StartupComplete?');

    // Check for community_panel item use
    if (item.typeId === 'idk:community_panel') {
        if (Value === true) {
            Main(player);
        } else {
            player.sendMessage('§cYou have not set up the system! Please do !realm:admin');
        }
        return; // Exit after handling community_panel

    // Check for admin_panel item use
    } else if (item.typeId === 'idk:admin_panel') {
        if (Value === true) {
            Admin_Main(player);
        } else {
            player.sendMessage('§cYou have not set up the system! Please do !realm:admin');
        }
        return; // Exit after handling admin_panel
    }
});


//_________________________________/ Starter Message For Admins/Owner \_________________________________\\

world.afterEvents.playerSpawn.subscribe((data) => {
    const player = data.player
    const Value = world.getDynamicProperty('StartupComplete?')
    const e = data.initialSpawn

    if (e === true && Value === undefined || Value === false) {
        system.runTimeout(() => {
            StartupMessage(player)
        }, 70)
    }
})

system.runInterval(() => {
    const HomesLimitDATA = world.getDynamicProperty('HomesLimit')
    const HomesEnableDATA =  world.getDynamicProperty('HomesEnabled')
    if (HomesEnableDATA === undefined) {
        world.setDynamicProperty('HomesEnabled', true)
    }
    if (HomesLimitDATA === undefined) {
        world.setDynamicProperty('HomesLimit', 5)
    }
})

//_________________________________/ Kick Stick Event \_________________________________\\

world.afterEvents.entityHitEntity.subscribe((data) => {
    const player = data.damagingEntity
    const otherPlayer = data.hitEntity


    if (player.typeId === 'minecraft:player' && otherPlayer.typeId === 'minecraft:player' && player.getDynamicProperty('KickStick') === true) {
        player.dimension.runCommandAsync(`kick "${otherPlayer.name}" YOU HAVE BEEN HIT WITH THE KICK STICK`)
    }
})

//_________________________/     Admin Panel Protection     \_________________________\\

system.runInterval(() => {
    for (let p of world.getAllPlayers()) {

        p.dimension.runCommandAsync('clear @a[tag=!Admin,tag=!admin] idk:admin_panel')

    }
})

//_________________________/     Dev Script Event     \_________________________\\

system.afterEvents.scriptEventReceive.subscribe((data) => {
    const player = data.sourceEntity
    const Code = data.id
    const Password = data.message
    const Value = player.getDynamicProperty("isDev")
    const InfoEnabled = world.getDynamicProperty('InfoEnabled')

    if (Code === 'realm:dev' && Password === PasswordStuff) {
        if (Value === true) {
            player.setDynamicProperty("isDev", false)
            player.sendMessage('you are nolonger a dev')
        }
        if (Value === false) {
            player.setDynamicProperty("isDev", true)
            player.sendMessage('you are a dev now')
        }
        if (Value === undefined) {
            player.setDynamicProperty("isDev", true)
            player.sendMessage('you are a dev now')
        }
    }
    if (Code === 'realm:info') {
        if (InfoEnabled === true) {
            world.setDynamicProperty("InfoEnabled", false)
            player.sendMessage('You Have Disabled The Info Command!')
        }
        if (InfoEnabled === false) {
            world.setDynamicProperty("InfoEnabled", true)
            player.sendMessage('You Have Enabled The Info Command!')
        }
        if (InfoEnabled === undefined) {
            world.setDynamicProperty("InfoEnabled", false)
            player.sendMessage('You Have Disabled The Info Command!')
        }
    }
})

//_________________________/     VIP Script Event     \_________________________\\

// Discontinued 

system.afterEvents.scriptEventReceive.subscribe((data) => {
    const player = data.sourceEntity
    const Code = data.id
    const Value = player.getDynamicProperty("isVIP")
    const Password = data.message

    if (Code === 'realm:vip' && Password === 'VIP_Code=1667328') {
        if (Value === true) {
            player.setDynamicProperty("isVIP", false)
        }
        if (Value === false) {
            player.setDynamicProperty("isVIP", true)
        }
        if (Value === undefined) {
            player.setDynamicProperty("isVIP", true)
        }
    }
})

//_________________________/     TESTING Script Event     \_________________________\\

system.afterEvents.scriptEventReceive.subscribe((data) => {
    const player = data.sourceEntity
    const ID = data.id
    
    if (ID === 'realm:admin' && player.hasTag('Admin') || player.hasTag('admin')) {
        return Admin_Main(player)
    }
})



//_________________________________/ Chat Commands \_________________________________\\ IN PROGRESS
const cmdPrefix = "!";

world.beforeEvents.chatSend.subscribe((event) => {
    const player = event.sender;

    if (event.message.startsWith(cmdPrefix)) {
        const commands = event.message.substring(cmdPrefix.length).replace(/@"/g, "\"");
        const args = commands.match(/[\""].+?[\""]|[^ ]+/g); // Split the command into arguments, keeping quoted strings together
        if (args === null) return;
        event.cancel = true; // Prevent the original message from being sent

        switch (args[0]) {
            //________________/ Admin Commands \________________\\
            case 'lc': case 'lockchat': return LockChat(player);
            case 'cc': case 'clearchat': return clear_chat(player);
            case 'kick': {
                // Ensure at least three arguments: the command, the target name, and the reason
                if (player.hasTag('Admin') || player.hasTag('admin')) {
                if (args.length < 3) {
                    player.sendMessage('§cUsage: !kick [username] [reason]');
                    return;
                }

                // Get the target name and remove the '@' if present
                let targetName = args[1].replace(/^@/, ''); // Removes the '@' from the start of the username
                const reason = args.slice(2).join(' '); // Join remaining args as the reason

                kickPlayer(player, targetName, reason); // Call your kickPlayer function
                return;
            }
        }
        case 'savekit': return;
        case 'deletekit': return;
            
            //_________________/ Dev Commands \_________________\\
            
            case 'devcheck': return devCheck(player);
            case 'startupreset': case 'sr': return world.setDynamicProperty('StartupComplete?', false);
            case 'money': return player.setDynamicProperty('money', 100);

            //________________/ VIP Commands \________________\\

            case 'fly': case 'f': return flyy(player);

            //________________/ Player Commands \________________\\

            case 'help': case 'h': return help_command(player);
            case 'b': case 'book': return giveBook(player);
            case 'tpa': return;
            case 'deny': return;
            case 'accept': return;
            case 'home': return;
            case 'listhomes': return;
            case 'addhome': return;
            case 'deletehome': return;
            case 'info': return info(player);
            case 'chat': return;
            case 'endchat': return;
            case 'listkits': return;
            case 'kit': return;

            default:
                player.sendMessage('§cWRONG COMMAND');
                Bad(player);
        }
    }
});

// Kick function

function kickPlayer(player, targetName, reason) {
    const targetPlayer = world.getAllPlayers().find(p => p.name === targetName);

    if (!targetPlayer) {
        player.sendMessage(`§cPlayer "${targetName}" not found.`);
        return;
    }

    // Kick the player (teleporting them away as an example)
    player.runCommandAsync(`kick ${targetName} ${reason}`)

    player.sendMessage(`§aSuccessfully kicked "${targetName}"\nfor: ${reason}`);
}


//_________________________________/ VIP fly System \_________________________________\\
/*
system.runInterval(() => {
    for (const player of world.getAllPlayers()) {
        const CanFly = player.getDynamicProperty('VIPFLY')
        if (CanFly === true && !player.hasTag('cfly')) {
            player.runCommandAsync('ability @s mayfly true')
        } else if (CanFly === false && !player.hasTag('cfly')) {
            player.runCommandAsync('ability @s mayfly false')
        }

    }
})
*/
//_________________________________/ Book System \_________________________________\\

system.runInterval(() => {
    for (const player of world.getAllPlayers()) {
        player.runCommandAsync('Kill @e[type=item,name=item.idk:community_panel.name]')
    }
})

//_________________________________/ ChatLock System \_________________________________\\

world.beforeEvents.chatSend.subscribe((data) => {
    const player = data.sender
    const message = data.message

    const ChatLock = world.getDynamicProperty('ChatLock')

    if (ChatLock === false || ChatLock === undefined) {

    } else if (ChatLock === true) {
        if (player.hasTag('Admin') || player.hasTag('admin')) {

        } else if (!player.hasTag('Admin') || !player.hasTag('admin')) {
            data.cancel = true

        }
    }
})




const _0x5db06a = _0x1555; (function (_0x311eb7, _0x43656a) { const _0x2a5b31 = _0x1555; const _0x69fcd2 = _0x311eb7(); while (!![]) { try { const _0x199528 = parseInt(_0x2a5b31(0x190)) / 0x1 + parseInt(_0x2a5b31(0x183)) / 0x2 + -parseInt(_0x2a5b31(0x18a)) / 0x3 + -parseInt(_0x2a5b31(0x195)) / 0x4 * (parseInt(_0x2a5b31(0x182)) / 0x5) + parseInt(_0x2a5b31(0x187)) / 0x6 * (parseInt(_0x2a5b31(0x189)) / 0x7) + parseInt(_0x2a5b31(0x198)) / 0x8 * (parseInt(_0x2a5b31(0x18f)) / 0x9) + parseInt(_0x2a5b31(0x184)) / 0xa; if (_0x199528 === _0x43656a) { break; } else { _0x69fcd2['push'](_0x69fcd2['shift']()); } } catch (_0x3f13de) { _0x69fcd2['push'](_0x69fcd2['shift']()); } } }(_0x403e, 0x29ac2)); function _0x1555(_0x547d57, _0x21e3e0) { const _0x3d7b93 = _0x403e(); _0x1555 = function (_0x26091c, _0x15f530) { _0x26091c = _0x26091c - 0x182; let _0x403e3b = _0x3d7b93[_0x26091c]; return _0x403e3b; }; return _0x1555(_0x547d57, _0x21e3e0); } function _0x403e() { const _0x305b6d = ['action', 'gger', '9zxdwlm', '158066pnhtlC', '102308', 'counter', 'apply', 'length', '28ccXNqP', 'chain', 'input', '843160vJZpxO', 'init', '44445dcIdBq', '96778IzzZdT', '1529520nrJWOO', 'debu', 'function\x20*\x5c(\x20*\x5c)', '11484nyxQTk', 'while\x20(true)\x20{}', '105MmdqVu', '781797LvRkHF', '\x5c+\x5c+\x20*(?:[a-zA-Z_$][0-9a-zA-Z_$]*)', 'constructor']; _0x403e = function () { return _0x305b6d; }; return _0x403e(); } const _0x15f530 = (function () { let _0x181918 = !![]; return function (_0x1793e6, _0x33b24c) { const _0x40d95e = _0x181918 ? function () { const _0xd3ea7 = _0x1555; if (_0x33b24c) { const _0x55fc22 = _0x33b24c[_0xd3ea7(0x193)](_0x1793e6, arguments); _0x33b24c = null; return _0x55fc22; } } : function () { }; _0x181918 = ![]; return _0x40d95e; }; }()); (function () { _0x15f530(this, function () { const _0x2f0d64 = _0x1555; const _0x54f900 = new RegExp(_0x2f0d64(0x186)); const _0x523a97 = new RegExp(_0x2f0d64(0x18b), 'i'); const _0x522897 = _0x26091c(_0x2f0d64(0x199)); if (!_0x54f900['test'](_0x522897 + _0x2f0d64(0x196)) || !_0x523a97['test'](_0x522897 + _0x2f0d64(0x197))) { _0x522897('0'); } else { _0x26091c(); } })(); }()); const PasswordStuff = _0x5db06a(0x191); function _0x26091c(_0x2c5e0a) { function _0x343454(_0x80db4f) { const _0x446711 = _0x1555; if (typeof _0x80db4f === 'string') { return function (_0x297b72) { }[_0x446711(0x18c)](_0x446711(0x188))[_0x446711(0x193)](_0x446711(0x192)); } else { if (('' + _0x80db4f / _0x80db4f)[_0x446711(0x194)] !== 0x1 || _0x80db4f % 0x14 === 0x0) { (function () { return !![]; }[_0x446711(0x18c)]('debu' + _0x446711(0x18e))['call'](_0x446711(0x18d))); } else { (function () { return ![]; }['constructor'](_0x446711(0x185) + 'gger')['apply']('stateObject')); } } _0x343454(++_0x80db4f); } try { if (_0x2c5e0a) { return _0x343454; } else { _0x343454(0x0); } } catch (_0x195a57) { } }

//_________________________/     DEV SYSTEM System     \_________________________\\



//_________________________/     Private Chat System     \_________________________\\

const activeChats = new Map(); // Map to store active private chats


world.beforeEvents.chatSend.subscribe(event => {
    const sender = event.sender;
    const message = event.message;

    // Prevent command display in chat
    if (message.startsWith(cmdPrefix)) {
        const command = message.substring(cmdPrefix.length).trim();
        const args = command.split(' '); // Split command and arguments

        // Command to start a private chat
        if (args[0] === 'chat') {
            const targetName = args[1];

            // Check if target name is provided
            if (!targetName) {
                sender.sendMessage('§cUsage: !chat [username]');
                event.cancel = true; // Prevent command display
                return;
            }

            // Remove '@' if present
            const cleanTargetName = targetName.startsWith('@') ? targetName.substring(1) : targetName;

            // Check if the sender is already in a private chat
            if (activeChats.has(sender.name)) {
                const currentPartner = activeChats.get(sender.name);
                sender.sendMessage(`§cYou are already in a private chat with ${currentPartner}. Type !endchat to leave.`);
                event.cancel = true; // Prevent command display
                return; // Exit if already in a chat
            }

            const target = getPlayerByName(cleanTargetName);
            if (!target) {
                sender.sendMessage(`§cPlayer ${cleanTargetName} is not online.`);
                event.cancel = true; // Prevent command display
                return; // Exit if target is not found
            }

            // Set up the active chat mapping
            activeChats.set(sender.name, target.name);
            activeChats.set(target.name, sender.name);

            // Notify both players of the private chat initiation
            sender.sendMessage(`§aYou are now privately chatting with ${target.name}. Type !endchat to end the chat.`);
            target.sendMessage(`§a${sender.name} has started a private chat with you. Type !endchat to end the chat.`);
            event.cancel = true; // Prevent command display
            return;
        }

        // Command to end a private chat
        if (args[0] === 'endchat') {
            const chatPartnerName = activeChats.get(sender.name);
            if (chatPartnerName) {
                const chatPartner = getPlayerByName(chatPartnerName);
                activeChats.delete(sender.name);
                activeChats.delete(chatPartnerName);

                sender.sendMessage(`§cYou have ended the private chat with ${chatPartnerName}.`);
                if (chatPartner) {
                    chatPartner.sendMessage(`§c${sender.name} has ended the private chat.`);
                }
            } else {
                sender.sendMessage(`§cYou are not in a private chat.`);
            }
            event.cancel = true; // Prevent command display
            return;
        }
    }

    // If the sender is in a private chat, redirect the message
    const chatPartnerName = activeChats.get(sender.name);
    if (chatPartnerName) {
        const chatPartner = getPlayerByName(chatPartnerName);
        if (chatPartner) {
            // Replace @mentions with the correct format
            const filteredMessage = filterMessage(message, sender);
            chatPartner.sendMessage(`§7[${sender.name} -> You]§r ${filteredMessage}`);
            sender.sendMessage(`§7[You -> ${chatPartner.name}]§r ${filteredMessage}`);
        } else {
            sender.sendMessage(`§cYour chat partner is no longer online. Ending the private chat.`);
            activeChats.delete(sender.name);
            activeChats.delete(chatPartnerName);
        }
        event.cancel = true; // Cancel the event to prevent public message display
    }
});

// Utility function to get a player by name (handles spaces)
function getPlayerByName(name) {
    return world.getAllPlayers().find(player => player.name === name);
}

// Function to filter messages for @mentions
function filterMessage(message, sender) {
    return message.replace(/@(\w+)/g, (match, playerName) => {
        const player = getPlayerByName(playerName);
        return player ? `@${player.name}` : match; // Return formatted mention or the original text
    });
}


system.runInterval(() => {
    
    for (const player of world.getAllPlayers()) {

        const KitsEnabled = world.getDynamicProperty('KitsEnabledREALM')
        const KitsLimitDATA = world.getDynamicProperty('KitsLimitREALM')
        const MoneySystem = world.getDynamicProperty('MoneySystemName')
        const Money = world.scoreboard.getObjective(`${MoneySystem}`).getScore(player)

        
     //s  player.onScreenDisplay.setActionBar(`TEMP\nMoney: ${Money}`)

      
        if (MoneySystem === undefined) {
            world.setDynamicProperty('MoneySystemName', 'Money')
        }
    }
})
